<?php

namespace App\Http\Controllers;

use App\Http\Requests\ClientStoreRequest;
use Illuminate\Http\Request;
use App\Models\Client;
use App\Models\State;
use App\Models\City;
use App\Models\Country;
use App\Models\Tenant;
use App\Models\ClientUser;
use Session;
use App\Models\User;
use Illuminate\Support\Facades\Hash;
use Carbon;
use App\Models\UserProceeding;
use Sum;
use Excel;
use App\Exports\UserProceedingExport;
//use Maatwebsite\Excel\Facades\Excel;

class ReportController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        //$this->middleware('auth');
    }

    /**
     * Index resource
     *
     * @return \Illuminate\Http\JsonResponse
     */
    public function index(Request $request) {
        //return $request;
        $startDate = Carbon\Carbon::now(); //returns current day
        $start = $startDate->firstOfMonth()->format('Y-m-d');
        //return $start = Carbon\Carbon::now()->startOfMonth();
        $users=User::get();

        $clients=Client::get();

        $charges=$request->charges;

        $hours=[];

        $uid=[];

        $totalhours='0';
        
        $totalrates='0';

        
        //return $userproceeding= UserProceeding::whereBetween('Date', array( Carbon\Carbon::parse($request->proceeding)->toDateTimeString(),   Carbon\Carbon::parse($request->from)->toDateTimeString()))->get();
        if($request->proceeding!='' && $request->from!='' && $request->user_id=='' && 
            $request->charges =='' && $request->client_id==''){
            //return 'if';
              return $userproceeding= UserProceeding::whereBetween('Date', array($request->proceeding, $request->from))->with('userdetail','userpricing','orderdetail','orderdetail.clientdetail')->get();

            foreach($userproceeding as $proceed){
                // $hour=explode(':',$proceed->advHours);
                  $hours[]=str_replace(':', '.',$proceed->advHours);
                  
                  if($proceed->userpricing!=''){
                   $totalrates+=$proceed->userpricing->rate;
                  }
                  array_push($uid, $proceed->id);
            }

            foreach($hours as $hour){
                $totalhours+=$hour;
            }



             return view('report.index',compact('start','users','userproceeding','clients','hours','charges','totalhours','totalrates'));

        }
        elseif($request->proceeding!='' && $request->from!='' && $request->user_id=='' && $request->charges !=''  && $request->client_id==''){
           //return 'elseifif';
            //return $request;
           $userproceeding= UserProceeding::whereBetween('Date', array($request->proceeding, $request->from))->with('userdetail','userpricing','orderdetail','orderdetail.clientdetail')->get();

            if(isset($userproceeding) && $userproceeding!='[]'){
                foreach($userproceeding as $proceed){
                    //$hour= explode(':',$proceed->advHours);
                    $hours[]=str_replace(':', '.',$proceed->advHours);
                    // return Sum('hours');
                    if($proceed->userpricing!=''){
                        $totalrates+=$proceed->userpricing->rate;
                    }
                    array_push($uid, $proceed->id);
                }
                
                foreach($hours as $hour){
                    $totalhours+=$hour;
                }
               
                 return view('report.index',compact('start','users','userproceeding','clients','hours','charges','totalhours','uid','totalrates'));
            }
             return view('report.index',compact('start','users','clients'));
           

        }elseif($request->proceeding!='' && $request->from!='' && $request->user_id!='' && $request->charges =='' && $request->client_id==''){
            //return 'elseif';
            $userproceeding= UserProceeding::where('advNo',$request->user_id)->whereBetween('Date', array($request->proceeding, $request->from))->with('userdetail','userpricing','orderdetail','orderdetail.clientdetail')->get();

            if(isset($userproceeding) && $userproceeding!='[]'){
                foreach($userproceeding as $proceed){
                    //$hour= explode(':',$proceed->advHours);
                    $hours[]=str_replace(':', '.',$proceed->advHours);
                    if($proceed->userpricing!=''){
                     $totalrates+=$proceed->userpricing->rate;
                    }
                    array_push($uid, $proceed->id);
                }
                foreach($hours as $hour){
                $totalhours+=$hour;
                }
                 return view('report.index',compact('start','users','userproceeding','clients','hours','totalhours','uid','totalrates'));
            }
             return view('report.index',compact('start','users','clients'));
           

        }
        elseif($request->proceeding!='' && $request->from!='' && $request->user_id!='' && $request->charges !=''  && $request->client_id==''){
           //return 'elseifif';
           $userproceeding= UserProceeding::where('advNo',$request->user_id)->whereBetween('Date', array($request->proceeding, $request->from))->with('userdetail','userpricing','orderdetail','orderdetail.clientdetail')->get();

            if(isset($userproceeding) && $userproceeding!='[]'){
                foreach($userproceeding as $proceed){
                    //$hour= explode(':',$proceed->advHours);
                    $hours[]=str_replace(':', '.',$proceed->advHours);
                    if($proceed->userpricing!=''){
                     $totalrates+=$proceed->userpricing->rate;
                    }
                    array_push($uid, $proceed->id);
                }
                //return $hours;
                //return $uid;
                //$totalhours+=$hours;
                foreach($hours as $hour){
                    $totalhours+=$hour;
                }
        

                //return $this->scopesumcommission($hours);
                 return view('report.index',compact('start','users','userproceeding','clients','hours','charges','totalhours','uid','totalrates'));
            }
             return view('report.index',compact('start','users','clients'));
           

        }elseif($request->proceeding!='' && $request->from!='' && $request->user_id!='' && $request->charges !='' && $request->client_id!=''){
            //return 'else';
             $userproceeding= UserProceeding::where('advNo',$request->user_id)->whereBetween('Date', array($request->proceeding, $request->from))->with('userdetail','userpricing','orderdetail','orderdetail.clientdetail')->get();
              if(isset($userproceeding) && $userproceeding!='[]'){
                  
            foreach($userproceeding as $proceed){
                //$hour= explode(':',$proceed->advHours);
                $hours[]=str_replace(':', '.',$proceed->advHours);
                if($proceed->userpricing!=''){
                 $totalrates+=$proceed->userpricing->rate;
                }
                    array_push($uid, $proceed->id);
            //return Sum('hours');
            }
            foreach($hours as $hour){
                $totalhours+=$hour;
            }
                return view('report.index',compact('start','users','userproceeding','clients','hours','charges','totalhours','uid','totalrates'));
            }
             return view('report.index',compact('start','users','clients'));
        }
        elseif($request->proceeding!='' && $request->from!='' && $request->user_id=='' && $request->charges !='' && $request->client_id!=''){
            //return 'ifelse';
            $clientid=$request->client_id;

              $userproceeding= UserProceeding::whereBetween('Date', array($request->proceeding, $request->from))->with('userdetail','userpricing','orderdetail','orderdetail.clientdetail')->whereHas('orderdetail.clientdetail', function($q) use ($clientid)
                 { $q->where('id','like','%'.$clientid.'%'); })->get();

            if(isset($userproceeding) && $userproceeding!='[]'){
                foreach($userproceeding as $proceed){
                    //$hour= explode(':',$proceed->advHours);
                    $hours[]=str_replace(':', '.',$proceed->advHours);
                    if($proceed->userpricing!=''){
                     $totalrates+=$proceed->userpricing->rate;
                    }
                    array_push($uid, $proceed->id);
                    //return Sum('hours');
                }
                foreach($hours as $hour){
                    $totalhours+=$hour;
                }
                return view('report.index',compact('start','users','userproceeding','clients','hours','charges','totalhours','uid','totalrates'));
            }
             return view('report.index',compact('start','users','clients'));
        }
        elseif($request->proceeding!='' && $request->from!='' && $request->user_id!='' && $request->charges =='' && $request->client_id!=''){
            //return 'ifelse';
            $clientid=$request->client_id;
            $userproceeding = UserProceeding::where('advNo',$request->user_id)->whereBetween('Date', array($request->proceeding, $request->from))->with('userdetail','userpricing','orderdetail','orderdetail.clientdetail')->whereHas('orderdetail.clientdetail', function($q) use ($clientid)
                 { $q->where('id','like','%'.$clientid.'%'); })->get();

              if(isset($userproceeding) && $userproceeding!='[]'){
            foreach($userproceeding as $proceed){
                //$hour= explode(':',$proceed->advHours);
                $hours[]=str_replace(':', '.',$proceed->advHours);
                if($proceed->userpricing!=''){
                 $totalrates+=$proceed->userpricing->rate;
                }
                array_push($uid, $proceed->id);
                //return Sum('hours');
            }
            foreach($hours as $hour){
                $totalhours+=$hour;
            }
             return view('report.index',compact('start','users','userproceeding','clients','hours','totalhours','uid','totalrates'));
            }
             return view('report.index',compact('start','users','clients'));
        }

        //return $hours;
        
        return view('report.index',compact('start','users','clients'));

    }


    public function exportTopdf(Request $request)
    {
        //return $request;
        

        $startDate = Carbon\Carbon::now(); //returns current day
        $start = $startDate->firstOfMonth()->format('Y-m-d');
        //return $start = Carbon\Carbon::now()->startOfMonth();
        $users=User::get();

        $clients=Client::get();

        $charges=$request->charges;

        $hours=[];

        $uid=[];

        $totalhours='0';
        
        $totalrates='0';

        
        if($request->proceeding!='' && $request->from!='' && $request->user_id=='' && 
            $request->charges =='' && $request->client_id==''){
            //return 'if';
              $userproceeding= UserProceeding::whereBetween('Date', array($request->proceeding, $request->from))->with('userdetail','userpricing','orderdetail','orderdetail.clientdetail')->get();

            foreach($userproceeding as $proceed){
                // $hour=explode(':',$proceed->advHours);
                  $hours[]=str_replace(':', '.',$proceed->advHours);
                  if($proceed->userpricing!=''){
                   $totalrates+=$proceed->userpricing->rate;
                  }
                  //Sum('hours');
            }

            foreach($hours as $hour){
                $totalhours+=$hour;
            }

              $pdf = \PDF::loadView('report.pdf.mail',compact('userproceeding','hours','totalhours','charges','totalrates'));
              

        }
        elseif($request->proceeding!='' && $request->from!='' && $request->user_id=='' && $request->charges !=''  && $request->client_id==''){
           //return 'elseifif';
            //return $request;
           $userproceeding= UserProceeding::whereBetween('Date', array($request->proceeding, $request->from))->with('userdetail','userpricing','orderdetail','orderdetail.clientdetail')->get();

            if(isset($userproceeding) && $userproceeding!='[]'){
                foreach($userproceeding as $proceed){
                    
                    $hours[]=str_replace(':', '.',$proceed->advHours);
                    
                    if($proceed->userpricing!=''){
                        $totalrates+=$proceed->userpricing->rate;
                    }
                    array_push($uid, $proceed->id);
                }
                
                foreach($hours as $hour){
                    $totalhours+=$hour;
                }
            }
                
                $pdf = \PDF::loadView('report.pdf.mail',compact('userproceeding','hours','totalhours','charges','totalrates'));
            
        

        }elseif($request->proceeding!='' && $request->from!='' && $request->user_id!='' && $request->charges =='' && $request->client_id==''){
            //return 'elseif';
            $userproceeding= UserProceeding::where('advNo',$request->user_id)->whereBetween('Date', array($request->proceeding, $request->from))->with('userdetail','userpricing','orderdetail','orderdetail.clientdetail')->get();

            if(isset($userproceeding) && $userproceeding!='[]'){
                foreach($userproceeding as $proceed){
                    //$hour= explode(':',$proceed->advHours);
                    $hours[]=str_replace(':', '.',$proceed->advHours);
                    if($proceed->userpricing!=''){
                     $totalrates+=$proceed->userpricing->rate;
                    }
            
                }
                foreach($hours as $hour){
                $totalhours+=$hour;
                }
                   $pdf = \PDF::loadView('report.pdf.mail',compact('userproceeding','hours','totalhours','charges','totalrates'));
            }
             
           

        }
        elseif($request->proceeding!='' && $request->from!='' && $request->user_id!='' && $request->charges !=''  && $request->client_id==''){
           //return 'elseifif';
           $userproceeding= UserProceeding::where('advNo',$request->user_id)->whereBetween('Date', array($request->proceeding, $request->from))->with('userdetail','userpricing','orderdetail','orderdetail.clientdetail')->get();

            if(isset($userproceeding) && $userproceeding!='[]'){
                foreach($userproceeding as $proceed){
                    //$hour= explode(':',$proceed->advHours);
                    $hours[]=str_replace(':', '.',$proceed->advHours);
                    if($proceed->userpricing!=''){
                     $totalrates+=$proceed->userpricing->rate;
                    }
                    array_push($uid, $proceed->id);
                }
                //return $hours;
                //return $uid;
                //$totalhours+=$hours;
                foreach($hours as $hour){
                    $totalhours+=$hour;
                }
                //return $totalhours;

                //return $this->scopesumcommission($hours);
                  $pdf = \PDF::loadView('report.pdf.mail',compact('userproceeding','hours','totalhours','charges','totalrates'));
            }
             
           

        }elseif($request->proceeding!='' && $request->from!='' && $request->user_id!='' && $request->charges !='' && $request->client_id!=''){
            //return 'else';
             $userproceeding= UserProceeding::where('advNo',$request->user_id)->whereBetween('Date', array($request->proceeding, $request->from))->with('userdetail','userpricing','orderdetail','orderdetail.clientdetail')->get();
              
              if(isset($userproceeding) && $userproceeding!='[]'){
                  
            foreach($userproceeding as $proceed){
                //$hour= explode(':',$proceed->advHours);
                $hours[]=str_replace(':', '.',$proceed->advHours);
                if($proceed->userpricing!=''){
                 $totalrates+=$proceed->userpricing->rate;
                }
                 array_push($uid, $proceed->id);
            }
            
            foreach($hours as $hour){
                $totalhours+=$hour;
            }
                  $pdf = \PDF::loadView('report.pdf.mail',compact('userproceeding','hours','totalhours','charges','totalrates'));
            }
             
        }
        elseif($request->proceeding!='' && $request->from!='' && $request->user_id=='' && $request->charges !='' && $request->client_id!=''){
            //return 'ifelse';
            $clientid=$request->client_id;

              $userproceeding= UserProceeding::whereBetween('Date', array($request->proceeding, $request->from))->with('userdetail','userpricing','orderdetail','orderdetail.clientdetail')->whereHas('orderdetail.clientdetail', function($q) use ($clientid)
                 { $q->where('id','like','%'.$clientid.'%'); })->get();

            if(isset($userproceeding) && $userproceeding!='[]'){
                foreach($userproceeding as $proceed){
                    //$hour= explode(':',$proceed->advHours);
                    $hours[]=str_replace(':', '.',$proceed->advHours);
                    if($proceed->userpricing!=''){
                     $totalrates+=$proceed->userpricing->rate;
                    }
                     array_push($uid, $proceed->id);
                    //return Sum('hours');
                }
                foreach($hours as $hour){
                    $totalhours+=$hour;
                }
                  $pdf = \PDF::loadView('report.pdf.mail',compact('userproceeding','hours','totalhours','charges','totalrates'));
            }
             
        }
        elseif($request->proceeding!='' && $request->from!='' && $request->user_id!='' && $request->charges =='' && $request->client_id!=''){
            //return 'ifelse';
            $clientid=$request->client_id;
            $userproceeding = UserProceeding::where('advNo',$request->user_id)->whereBetween('Date', array($request->proceeding, $request->from))->with('userdetail','userpricing','orderdetail','orderdetail.clientdetail')->whereHas('orderdetail.clientdetail', function($q) use ($clientid)
                 { $q->where('id','like','%'.$clientid.'%'); })->get();

              if(isset($userproceeding) && $userproceeding!='[]'){
            foreach($userproceeding as $proceed){
                //$hour= explode(':',$proceed->advHours);
                $hours[]=str_replace(':', '.',$proceed->advHours);
                if($proceed->userpricing!=''){
                 $totalrates+=$proceed->userpricing->rate;
                }
                 array_push($uid, $proceed->id);
                //return Sum('hours');
            }
            foreach($hours as $hour){
                $totalhours+=$hour;
            }
           
            }
        }
        
            $pdf = \PDF::loadView('report.pdf.mail',compact('userproceeding','hours','totalhours','charges','totalrates'));
        

        return $pdf->stream('report.pdf');
    }
    
    public function  exportToExcel(Request $request){   

        //return $request;

         $hours=[];

         $totalhours='0';
        
        if($request->proceeding!='' && $request->from!='' && $request->user_id=='' && 
                $request->charges =='' && $request->client_id==''){
            //return 'if';
            return $arrays =  UserProceeding::select(
                   'user_proceedings.DATE',
                   'users.name as Advocate','orders.id as order_id','clients.name as Client',
                'user_proceedings.Proceedings',
                'user_proceedings.advHours',
                'user_pricings.rate'
                )->whereBetween('user_proceedings.Date', array($request->proceeding, $request->from))->leftjoin('users', 'users.id', '=', 'user_proceedings.advNo')->leftjoin('user_pricings','user_pricings.userId','=','user_proceedings.advNo')->leftjoin('orders','orders.id','=','user_proceedings.orderId')->leftjoin('clients','clients.id','=','orders.clientId')->GroupBy('user_proceedings.id')->get()->toArray();

            /*foreach($arrays as $proceed){
                //$hour= explode(':',$proceed->advHours);
                $hours[]=str_replace(':', '.',$proceed->advHours);
                //return Sum('hours');
            }
            foreach($hours as $hour){
                $totalhours+=$hour;
            }*/
            

            return Excel::download(new UserProceedingExport($arrays,$hours,$totalhours), 'Report.csv');

        }
        elseif($request->proceeding!='' && $request->from!='' && $request->user_id!='' && $request->charges =='' && $request->client_id==''){
            //return 'elseif';
            $arrays =  UserProceeding::select(
                   'user_proceedings.DATE',
                   'users.name as Advocate','clients.name as Client',
                'user_proceedings.Proceedings',
                'user_proceedings.advHours'
                ,'user_pricings.rate'
                )->where('user_proceedings.advNo',$request->user_id)->whereBetween('user_proceedings.Date', array($request->proceeding, $request->from))->leftjoin('users', 'users.id', '=', 'user_proceedings.advNo')->leftjoin('user_pricings','user_pricings.userId','=','user_proceedings.advNo')->leftjoin('orders','orders.id','=','user_proceedings.orderId')->leftjoin('clients','clients.id','=','orders.clientId')->GroupBy('user_proceedings.id')->get()->toArray();

            /*foreach($arrays as $proceed){
                //$hour= explode(':',$proceed->advHours);
                $hours[]=str_replace(':', '.',$proceed->advHours);
                //return Sum('hours');
            }
            foreach($hours as $hour){
                $totalhours+=$hour;
            }*/

            return Excel::download(new UserProceedingExport($arrays,$hours,$totalhours), 'Report.csv');
               

            }
            elseif($request->proceeding!='' && $request->from!='' && $request->user_id!='' && $request->charges !=''  && $request->client_id==''){
               //return 'elseifif';

                $arrays =  UserProceeding::select(
                   'user_proceedings.DATE',
                   'users.name as Advocate','clients.name as Client',
                'user_proceedings.Proceedings',
                'user_proceedings.advHours','user_pricings.rate'
                )->where('user_proceedings.advNo',$request->user_id)->whereBetween('user_proceedings.Date', array($request->proceeding, $request->from))->leftjoin('users', 'users.id', '=', 'user_proceedings.advNo')->leftjoin('user_pricings','user_pricings.userId','=','user_proceedings.advNo')->leftjoin('orders','orders.id','=','user_proceedings.orderId')->leftjoin('clients','clients.id','=','orders.clientId')->GroupBy('user_proceedings.id')->get()->toArray();

                  return Excel::download(new UserProceedingExport($arrays), 'Report.csv');
     
        
            }elseif($request->proceeding!='' && $request->from!='' && $request->user_id!='' && $request->charges !='' && $request->client_id!=''){

                $arrays =  UserProceeding::select(
                   'user_proceedings.DATE',
                   'users.name as Advocate','clients.name as Client',
                'user_proceedings.Proceedings',
                'user_proceedings.advHours','user_pricings.rate'
                )->where('user_proceedings.advNo',$request->user_id)->whereBetween('user_proceedings.Date', array($request->proceeding, $request->from))->leftjoin('users', 'users.id', '=', 'user_proceedings.advNo')->leftjoin('user_pricings','user_pricings.userId','=','user_proceedings.advNo')->leftjoin('orders','orders.id','=','user_proceedings.orderId')->leftjoin('clients','clients.id','=','orders.clientId')->GroupBy('user_proceedings.id')->get()->toArray();

                  return Excel::download(new UserProceedingExport($arrays), 'Report.csv');
                 
            }
            elseif($request->proceeding!='' && $request->from!='' && $request->user_id=='' && $request->charges !='' && $request->client_id!=''){

               $arrays =  UserProceeding::select(
                   'user_proceedings.DATE',
                   'users.name as Advocate','clients.name as Client',
                'user_proceedings.Proceedings',
                'user_proceedings.advHours','user_pricings.rate'
                )->where('user_proceedings.advNo',$request->user_id)->whereBetween('user_proceedings.Date', array($request->proceeding, $request->from))->leftjoin('users', 'users.id', '=', 'user_proceedings.advNo')->leftjoin('user_pricings','user_pricings.userId','=','user_proceedings.advNo')->leftjoin('orders','orders.id','=','user_proceedings.orderId')->leftjoin('clients','clients.id','=','orders.clientId')->GroupBy('user_proceedings.id')->get()->toArray();

                  return Excel::download(new UserProceedingExport($arrays), 'Report.csv');
                 
            }
            elseif($request->proceeding!='' && $request->from!='' && $request->user_id!='' && $request->charges =='' && $request->client_id!=''){

                $arrays =  UserProceeding::select(
                   'user_proceedings.DATE',
                   'users.name as Advocate','clients.name as Client',
                'user_proceedings.Proceedings',
                'user_proceedings.advHours','user_pricings.rate'
                )->where('user_proceedings.advNo',$request->user_id)->whereBetween('user_proceedings.Date', array($request->proceeding, $request->from))->leftjoin('users', 'users.id', '=', 'user_proceedings.advNo')->leftjoin('user_pricings','user_pricings.userId','=','user_proceedings.advNo')->leftjoin('orders','orders.id','=','user_proceedings.orderId')->leftjoin('clients','clients.id','=','orders.clientId')->GroupBy('user_proceedings.id')->get()->toArray();

                  return Excel::download(new UserProceedingExport($arrays), 'Report.csv');
            }
             
    }

    /*public function  exportToExcel(Request $request){   

        //return $request;
        return Excel::download(new UserProceedingExport($request->proceeding ?? '', $request->from ?? '' ,$request->user_id ?? '' ,$request->charges ?? '',$request->client_id ?? ''), 'Report Data.csv');
    }*/
        
    

    public function create()
    {
        $states= State::get();
        $cities =City::get();
        $countries=Country::get();
        if (Session::has('tenantid')){
            $tenantid=Session::get('tenantid');
        }else{
            $tenantid='';
        }
        //return $tenantid;
        $tenants=Tenant::get();
        if (Session::has('tenantid')){
        return view('client.create',compact('states','cities','countries','tenants','tenantid'));
        }
        else{
          return view('client.create',compact('states','cities','countries','tenants','tenantid')); 
        }
    }

    public function store(Request $request) {
            //return $request;

            /*if(isset($request->file))
            {

                $image = $request->file('file');
                $fileInfo = $image->getClientOriginalName();
                $uniqueId= time().mt_rand();

                $filename = $uniqueId;
                $extension = pathinfo($fileInfo, PATHINFO_EXTENSION);
                $file_name= $filename.'.'.$extension;
                $image->move('images\upload\client/',$file_name);
                $request['uploadfile']= $file_name;
            }*/
            //return $request;
            if(isset($request->tenantid) || $request->tenantid!=''){
                $request['tenant_id']=$request->tenantid;
            }else{
                $request['tenant_id']=$request->tenant_id;
            }
           $client= Client::create($request->except('_token','file'));
            $user['tenant_id']=$request->tenantid;
             $user['role_id']='13';
             $user['name']=$request->name;
             $user['mobile']=$request->mobile;
             $user['email']=$request->email;
             $user['password']=$request->password;
         User::create($user);
            return redirect()->route('client.index');
    }

    /**
     * Get single resource
     *
     * @param Client $client
     *
     * @return \Illuminate\Http\JsonResponse
     */

    public function listuser(){

         $userlist=ClientUser::with('clientdetail','userdetail')->get();

        return view('client.userlist',compact('userlist'));
    }
    public function show(Request $request,$id)
    {

    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
            //return $id;

            $client= Client::where('id',$id)->with('tenantdetail')->first();

            $states= State::get();
            $cities =City::get();
            $countries=Country::get();
            $tenants=Tenant::get();
            return view('client.edit',compact('client','states','cities','countries','tenants'));
    }

    /**
     * Update single resource
     *
     * @param ClientStoreRequest $request
     * @param Client $client
     *
     * @return \Illuminate\Http\JsonResponse
     */
    public function update(Request $request,$id ) {
        //return $request;
        /*if(isset($request->file))
            {

                $image = $request->file('file');
                $fileInfo = $image->getClientOriginalName();
                $uniqueId= time().mt_rand();

                $filename = $uniqueId;
                $extension = pathinfo($fileInfo, PATHINFO_EXTENSION);
                $file_name= $filename.'.'.$extension;
                $image->move('images\upload\client/',$file_name);
                $request['uploadfile']= $file_name;
            }*/
            $request['password']=Hash::make($request->password);
        $client= Client::where('id',$id)->update($request->except('_token','_method'));
        return redirect()->route('client.index');

    }

    public function clientsearch(Request $request)
    {
        if($request->get('query')!=''){
             $query = $request->get('query');
                $searchcategory = Client::where('name','like', '%'.$query.'%')->select('id','name')->get();
        }
        return response()->json($searchcategory);
    }

    public  function clientdelete($id)
    {
       try{
        //return $id;
            $client = Client::where('id',$id)->delete();
            return \Response::json(["status" => "success", "message" => "client delete"]);
        }catch (Exception $e) {
            return \Response::json(["status" => "danger", "message" => $e->getMessage()]);
        }
    }

    /**
     * Store new resource
     *
     * @param ClientStoreRequest $request
     *
     * @return \Illuminate\Http\JsonResponse
     */
    

    /**
     * Destroy single resource
     *
     * @param Client $client
     *
     * @return \Illuminate\Http\JsonResponse
     * @throws \Exception
     */
    public function destroy($id ) {
    }

    /**
     * Destroy resources by ids
     *
     * @param Request $request
     *
     * @return \Illuminate\Http\JsonResponse
     * @throws \Exception
     */
}
